//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "QSpgpPass.h"
#include "mixmastdlg.h"
#include "fileman.h"
#include "pgp.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPassphrase *Passphrase=NULL;
//char *sessionkey=NULL;
//---------------------------------------------------------------------------
__fastcall TPassphrase::TPassphrase(TComponent* Owner)
  : TDataModule(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TPassphrase::~TPassphrase()
{
   if (sessionkey) delete sessionkey;
   Timer->Enabled = false; Clear();
   delete phrases;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::PassphraseCreate(TObject *Sender)
{
   phrases = new TStringList();
   Timer->Enabled = false;
   seconds = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::TimerTimer(TObject *Sender)
{
   seconds--;
 //AnsiString msg = s(seconds)+"/"+s(phrases->Count);
 //ActMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)msg.c_str());
   if (seconds==0)
   {
      Timer->Enabled = false;
      Clear();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Clear()
{
   if (phrases) for (int i=0; i<phrases->Count; i++)
      delete dynamic_cast<TDataBuf*>(phrases->Objects[i]);
   phrases->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Add(AnsiString idtext8, AnsiString phrase)
{
   Timer->Enabled = false;
   seconds = KEEPPASSWORDMIN*60;
   if (seconds<1) return;

   sessionkey = (char*)ActMainForm->Perform(WM_GETSESSIONKEY,0,0);
   /*if (!sessionkey)
   {
      //AnsiString mixrandbin = MixDir()+"mixrand.bin";
      //if (FileExists(mixrandbin)) rand->LoadFromFile(seskeystxt);
      //rand->Seek(ofs,soFromBeginning);
      //sessionkey = new char[128];
      //rand->Read(sessionkey,127);
      //delete rand;
   }*/
      if (ISDESIGNING)
      {
         AnsiString key,str;
         AnsiString seskeystxt = AppDir+"seskeys.txt";
         TStringList *seskeys = new TStringList();
         if (FileExists(seskeystxt)) seskeys->LoadFromFile(seskeystxt);
         for (int i=0; i<128; i++)
         {
            int x = sessionkey[i]; str = s(x);
            while (str.Length()<4) str = " "+str;
            key += " "+str;
         }
         seskeys->Add(key);
         seskeys->SaveToFile(seskeystxt);
         delete seskeys;
      }

   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   Delete(idtext8);

   TDataBuf *phrasebuf = new TDataBuf(phrase.c_str(),phrase.Length());
   phrasebuf->sensitive = true;
   phrasebuf->Encrypt(s(sessionkey));
   phrases->AddObject(idtext8,phrasebuf);

   Timer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Delete(AnsiString idtext8)
{
   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   int idx; if ((idx=phrases->IndexOf(idtext8))>=0)
   {
      delete (TDataBuf*)phrases->Objects[idx];
      phrases->Delete(idx);
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPassphrase::Get(AnsiString idtext8)
{
   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);

   int idx;
   AnsiString phrase;
   if ((idx=phrases->IndexOf(idtext8))>=0)
   {
      TDataBuf *phrasebuf = (TDataBuf*)phrases->Objects[idx];
      if (phrasebuf) phrasebuf->Decrypt(sessionkey);
      phrase = phrasebuf->str();
   }
   return phrase;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPassphrase::Get(TStrings *idtext8s, AnsiString &idtext8)
{
   AnsiString phrase;
   for (int i=0; i<idtext8s->Count; i++)
   {
      idtext8 = idtext8s->Strings[i];
      if ((phrase=Get(idtext8))!="")
         break;
   }
   return phrase;
}
//---------------------------------------------------------------------------
